Index: include/asterisk/utils.h
===================================================================
--- include/asterisk/utils.h	(revision 148468)
+++ include/asterisk/utils.h	(working copy)
@@ -642,6 +642,31 @@
 
 #define ARRAY_LEN(a) (sizeof(a) / sizeof(a[0]))
 
+
+/* Definition for Digest authorization */
+struct ast_http_digest {
+	char username[80];
+	char nonce[32];
+	char uri[256];
+	char realm[256];
+	char domain[256];
+	char response[256];
+	int qop;		/* Flag set to 1, if we send/recv qop="quth" */
+	char cnonce[256];
+	char opaque[32];
+	char nc[32];
+};
+
+/*!
+ *\brief Parse digest authorization header.
+ *\return Returns -1 if we have no auth or something wrong with digest.
+ *\note This function may be used for Digest request and responce header.
+ * request arg is set to nonzero, if we parse Digest Request.
+ * pedantic arg can be set to nonzero if we need to do addition Digest check.
+ */
+int ast_parse_digest(const char *digest, struct ast_http_digest *d, int request, int pedantic);
+
+
 #ifdef AST_DEVMODE
 #define ast_assert(a) _ast_assert(a, # a, __FILE__, __LINE__, __PRETTY_FUNCTION__)
 static void force_inline _ast_assert(int condition, const char *condition_str, 
Index: include/asterisk/http.h
===================================================================
--- include/asterisk/http.h	(revision 148468)
+++ include/asterisk/http.h	(working copy)
@@ -52,28 +52,40 @@
  * be run earlier in the startup process so modules have it available.
  */
 
+/*! \brief HTTP Request methods known by Asterisk */
+enum ast_http_method {
+	AST_HTTP_UNKNOWN = 0,	/*!< Unknown response */
+	AST_HTTP_GET,
+	AST_HTTP_POST,
+	AST_HTTP_HEAD,
+	AST_HTTP_PUT		/*!< Not supported in Asterisk */
+};
 
+struct ast_http_uri;
+
 /*! \brief HTTP Callbacks take the socket
 
-   \note The method and the path as arguments and should
-   return the content, allocated with malloc().  Status should be changed to reflect
-   the status of the request if it isn't 200 and title may be set to a malloc()'d string
-   to an appropriate title for non-200 responses.  Content length may also be specified. 
-\verbatim   
-   The return value may include additional headers at the front and MUST include a blank 
-   line with \r\n to provide separation between user headers and content (even if no
-   content is specified) 
+   \note The callback function get server instance, uri, http method,
+   get method variable (if present in uri) and http headers as arguments
+   and should ast_http_send() function for sending content allocated
+   with malloc() and/or content from opeened file descriptor.
+   
+   Status and status text should be put as argument in ast_http_send()
+   function to reflect the status of the request. (200 or 304, for example).
+   Content length calculated by ast_http_send() function internality. 
+
+   Static content indicated in argument passed to ast_http_send() function.
+
+\verbatim
+   All addition http response headers must be send as separate malloc'ated
+   string, and must be not existed in responce content! No addition line
+   with \r\n are required.
 \endverbatim
+
+   For error responce can be used ast_http_error() function.
 */
+typedef int (*ast_http_callback)(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params, struct ast_variable *headers);
 
-enum ast_http_method {
-	AST_HTTP_GET = 0,
-	AST_HTTP_POST,
-};
-struct ast_http_uri;
-
-typedef struct ast_str *(*ast_http_callback)(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *params, struct ast_variable *headers, int *status, char **title, int *contentlength);
-
 /*! \brief Definition of a URI handler */
 struct ast_http_uri {
 	AST_LIST_ENTRY(ast_http_uri) entry;
@@ -81,12 +93,6 @@
 	const char *uri;
 	ast_http_callback callback;
 	unsigned int has_subtree:1;
-	/*! This handler serves static content */
-	unsigned int static_content:1;
-	/*! This handler accepts GET requests */
-	unsigned int supports_get:1;
-	/*! This handler accepts POST requests */
-	unsigned int supports_post:1;
 	/*! Structure is malloc'd */
 	unsigned int mallocd:1;
 	/*! Data structure is malloc'd */
@@ -97,6 +103,9 @@
 	const char *key;
 };
 
+/* Get cookie from Request headers */
+struct ast_variable *ast_http_get_cookies(struct ast_variable *headers);
+
 /*! \brief Register a URI handler */
 int ast_http_uri_link(struct ast_http_uri *urihandler);
 
@@ -106,10 +115,48 @@
 /*! \brief Unregister all handlers with matching key */
 void ast_http_uri_unlink_all_with_key(const char *key);
 
-/*! \brief Return an ast_str malloc()'d string containing an HTTP error message */
-struct ast_str *ast_http_error(int status, const char *title, const char *extra_header, const char *text);
+/*! \brief Return http method name string */
+char *ast_get_http_method(enum ast_http_method method);
 
+/*! \brief Return mime type based on extension */
+char *ast_ftype2mtype(const char *ftype);
+
+/*! \brief Return manager id, if exist, from request headers */
+uint32_t manid_from_vars(struct ast_variable *headers);
+
+/*! \brief Generic function for sending http/1.1 responce.
+  \note Function make http responce header from status_code,
+  status_header and http_header.
+
+  Extra http header MUST BE only present in http_header argument.
+  Argument "out" contain only content of response (no headers!).
+
+  Http content can be constructed from mallocated argument "out", if
+  it is not NULL.
+  And, if fd is not null, from opened (for reading) file.
+
+  This function calculate content-lenght http header itself.
+ 
+  if http_header or out argument have not NULL value, this function
+  free memory, mallocated by caller and close http socket before exit.
+  
+  This function don't close file, identifide in fd variable.
+ */
+void ast_http_send(struct ast_tcptls_session_instance *ser, enum ast_http_method method, int status_code, const char *status_title, struct ast_str *http_header, struct ast_str *out, const int fd, unsigned int static_content);
+
+/* \brief Send http "401 Unauthorized" responce and close socket*/
+void ast_http_auth(struct ast_tcptls_session_instance *ser, const char *realm, const unsigned long nonce, const unsigned long opaque, int stale, const char *text);
+
+/* \brief Send HTTP error message and close socket */
+void ast_http_error(struct ast_tcptls_session_instance *ser, int status, const char *title, const char *text);
+
 /*! \brief Return the current prefix */
 void ast_http_prefix(char *buf, int len);
 
+
+/* \brief get post variables from client Request Entity-Body, if content type
+ is application/x-www-form-urlencoded. */
+struct ast_variable *get_post_vars(struct ast_tcptls_session_instance *ser, struct ast_variable *headers);
+
+
 #endif /* _ASTERISK_SRV_H */
Index: main/utils.c
===================================================================
--- main/utils.c	(revision 148468)
+++ main/utils.c	(working copy)
@@ -1760,6 +1760,115 @@
 	return 0;
 }
 
+
+/*!
+ *\brief Parse digest authorization header.
+ *\return Returns -1 if we have no auth or something wrong with digest.
+ *\note	This function may be used for Digest request and responce header.
+ * request arg is set to nonzero, if we parse Digest Request.
+ * pedantic arg can be set to nonzero if we need to do addition Digest check.
+ */
+int ast_parse_digest(const char *digest, struct ast_http_digest *d, int request, int pedantic) {
+	int i;
+	char *c, key[512], val[512], tmp[512];
+
+	if(ast_strlen_zero(digest) || d == NULL)
+		return -1;
+
+	ast_copy_string(tmp, digest, sizeof(tmp));
+
+	c = ast_skip_blanks(tmp);
+	
+	if (strncasecmp(tmp, "Digest ", strlen("Digest "))) {
+		ast_log(LOG_WARNING, "Missing Digest.\n");
+		return -1;
+	}
+	c += strlen("Digest ");
+
+	/* clear digest data */
+	memset(d, 0, sizeof(struct ast_http_digest));
+
+	/* lookup for keys/value pair */
+        while (*c && *(c = ast_skip_blanks(c))) {
+
+		/* find key */
+		i = 0;
+		while (*c && *c != '=' && *c != ',' && !isspace(*c) )
+			key[i++] = *c++;
+		key[i] = '\0';
+		c = ast_skip_blanks(c);
+		if (*c == '=') {
+			c = ast_skip_blanks(++c);
+			i = 0;
+			if (*c == '\"') {
+				/* in quotes. Skip first and look for last */
+				c++;
+				while (*c && *c != '\"') {
+					if (*c == '\\' && c[1] != '\0') /* unescape chars */
+						c++;
+					val[i++] = *c++;
+				}
+			} else {
+				/* token */
+				while (*c && *c != ',' && !isspace(*c) )
+					val[i++] = *c++;
+			}
+			val[i] = '\0';
+		}
+
+		while (*c && *c != ',')
+			c++;
+		if (*c)
+			c++;
+
+		if (!strcasecmp(key, "username"))
+			strncpy(d->username, val, sizeof(d->username)-1);
+		else if (!strcasecmp(key, "realm"))
+			strncpy(d->realm, val, sizeof(d->realm)-1);
+		else if (!strcasecmp(key, "nonce"))
+			strncpy(d->nonce, val, sizeof(d->nonce)-1);
+		else if (!strcasecmp(key, "uri"))
+			strncpy(d->uri, val, sizeof(d->uri)-1);
+		else if (!strcasecmp(key, "domain"))
+			strncpy(d->domain, val, sizeof(d->domain)-1);
+		else if (!strcasecmp(key, "response"))
+			strncpy(d->response, val, sizeof(d->response)-1);
+		else if (!strcasecmp(key, "algorithm")) {
+			if (strcasecmp(val, "MD5")) {
+				ast_log(LOG_WARNING, "Digest algorithm: \"%s\" not supported.\n", val);
+				return -1;
+			}
+		} else if (!strcasecmp(key, "cnonce"))
+			strncpy(d->cnonce, val, sizeof(d->cnonce)-1);
+		else if (!strcasecmp(key, "opaque"))
+			strncpy(d->opaque, val, sizeof(d->opaque)-1);
+		else if (!strcasecmp(key, "qop") && !strcasecmp(val, "auth"))
+			d->qop = 1;
+		else if (!strcasecmp(key, "nc")) {
+			unsigned long u;
+			if (sscanf(val, "%lx", &u) != 1) {
+				ast_log(LOG_WARNING, "Incorrect Digest nc value: \"%s\".\n", val);
+				return -1;
+			}
+			strncpy(d->nc, val, sizeof(d->nc)-1);
+		}
+	}
+	/* Digest checkout */
+	if (!*d->realm || !*d->nonce)
+		return -1; /* "realm" and "nonce" MUST be always exist */
+
+	if (!request) {
+		/* Additional check for Digest response */
+		if (!*d->username || !*d->uri || !*d->response)
+			return -1;
+		
+		if(pedantic && d->qop && (!*d->cnonce || !*d->nc))
+			return -1;
+	}
+	
+	return 0;
+}
+
 #ifndef __AST_DEBUG_MALLOC
 int _ast_asprintf(char **ret, const char *file, int lineno, const char *func, const char *fmt, ...)
 {
